<?php

$operation = Currator::path_query ('operation');
$picture = Currator::path_query ('image');
$photos = Currator::path_query ('gallery');
$caption = str_replace ("\\'", "'", urldecode (Currator::path_query ('caption')));

$success = false;
$is_xml = true;

switch ($operation) {
	case "save_caption" :
		$gallery_loc = Currator::create_photo_uri ($photos);
		$picture_loc = Currator::photo_uri_to_image_uri ($gallery_loc . $picture);
		$pic_cap = array ($picture_loc=>$caption);
		$gallery =& smr_gallery ($gallery_loc);
		$success = $gallery->UpdateCaptions ($pic_cap);
		$new_cap = $gallery->_pictures[$picture_loc]->Caption ();
		break;
	case "view_thumbnail" :
	case "view_slide" :
		$is_xml = false;
		$gallery_loc = Currator::create_photo_uri ($photos);
		$gallery =& smr_gallery ($gallery_loc);
		$picture_loc = Currator::photo_uri_to_image_uri ($gallery_loc . $picture);
		$image_path = $gallery->_pictures[$picture_loc]->_abs_path;
		
		if ("view_thumbnail" == $operation) {
			Picture::SendImage ($image_path, THUMB_WIDTH, THUMB_HEIGHT);
		} else {
			Picture::SendImage ($image_path, SLIDE_WIDTH, SLIDE_HEIGHT);
		}
		break;
}

$result_code = "fail";

if ($success) {
	$result_code = "success";
}

// set the content-type for accurate client handling
// the xml is semi-fluid.
if ($is_xml) {
header ('Content-type: text/xml; charset=' . get_settings ('blog_charset'), true);
echo '<?xml version="1.0" encoding="' . get_settings ('blog_charset') . '"?' . '>';
?>
<samsara>
	<meta>
		<action><?php _e ($operation); ?></action>
		<result><?php _e ($result_code); ?></result>
		<request>
			<picture><?php _e ($picture); ?></picture>
			<gallery><?php _e ($photos); ?></gallery>
			<caption><?php _e ($caption); ?></caption>		
		</request>
	</meta>
	<photos id="<?php _e ($photos); ?>">
		<photo id="<?php _e ($picture); ?>">
			<caption><?php _e ($new_cap); ?></caption>
		</photo>
	</photos>
</samsara>
<?php } ?>
