<?php

/*
 * a singleton object that manages the Gallery
 */
class Currator {
	var $gallery;
	var $all_galleries;
	var $gallery_root;
	
	//we may want to move te forbbideen dirs to the Currator
	
	// this is a private method, but php 4 does not support the concept
	function Currator ($is_singleton = false) {
		// get the gallery by passing the gallery root
		if (! $is_singleton) {
			// $this = false;
			return;
		}
		
		$this->gallery_root = ABSPATH . GALLERY_FOLDER;
		$gallery_address = SITE_URL . GALLERY_ROOT;
	
		$this->gallery = new Gallery ($gallery_address, $this->gallery_root);
		$this->all_galleries[$this->gallery->Location ()] = $this->gallery;
		$this->GetMatchingGalleries ('/', $this->gallery, $this->all_galleries);
	}
	
	// this is the public method that returns the singleton instance of Currator
	function GetInstance () {
		static $instance;
		//$instance;
		
		if (! isset ($instance)) {
			$c = __CLASS__;

            $instance = new $c (true);
        }
		
		return $instance;
	}
	
	
	// returns a random picture from the state gallery and subgalleries
	function GetRandomImage ($match_loc = '/') {
		$all_galleries = array ();
		
		// recursive search for galleries that match the location
		$this->GetMatchingGalleries ($match_loc, $this->gallery, $all_galleries);
		
		$rnd_gallery = GetRandomMapItem ($all_galleries);
		
		if (! $rnd_gallery) {
			return;
		}
		
		$rnd_picture = GetRandomMapItem ($rnd_gallery->Pictures ());
		
		return $rnd_picture;
	}
	
	
	// returns the matching gallery
	function GetMatchingGalleries ($match_loc = '/', $gallery, & $all_galleries) {
		foreach ($gallery->Galleries () as $location=>$sub_gallery) {
			if (ereg ($match_loc, $location)) {
				$all_galleries[$location] = $sub_gallery;
			}
			
			$this->GetMatchingGalleries ($match_loc, $sub_gallery, $all_galleries);
		}
	}
	
	
	/* class methods */

	// returns a parameter from the path or query of the request
	function path_query ($param = 'gallery') {
		global $wp_rewrite;
		static $params;
		
		if (isset ($params)) {
			if (array_key_exists ($param, $params)) {
				return $params[$param];
			}
			
			return;
		}
		
		// we build params from the path, then overlay them upon $_REQUEST
		// we also need to seperate the image from the gallery
		$params = array ();
		
		foreach ($_REQUEST as $key=>$val) {
			// todo: clean some values if needed
			$params[$key] = $val;
		}
		
		$uri_path = preg_replace ('/\?.*$/', '',  $_SERVER['REQUEST_URI']);
		$has_path_info =  false;
		
		if ("" != strstr ($uri_path, GALLERY_ROOT) && isset ($wp_rewrite) && $wp_rewrite->using_permalinks ()) {
			$has_path_info =  true;
		}
		
		// page from path always over-writes the $_REQUEST
		if ($has_path_info && "" != strstr ($uri_path, '/page/')) {
			$path_params = explode ('/page/', $uri_path);
			
			$page = abs (intval ($path_params[1]));
			
			$params['page'] = $page;
		}
		
		if (! isset ($params['page']) || 0 == $params['page']) {
			$params['page'] = 1;
		}
		
		// all forms of request treat the gallery and image a single entity,
		// location. The location is always location split into its parts.
		if (array_key_exists (GALLERY_PARAM, $params)) {
			$gallery = $params[GALLERY_PARAM];
		}
		else {
			$gallery = "";
		}
		
		if ($has_path_info) {
			$path_params = explode ('/page/', $uri_path);
			
			$gallery = str_replace (GALLERY_ROOT, '/', $path_params[0]);
		}
		
		if ("" != $gallery) {
			if (strpos ($gallery, '.') == 0 && strrpos ($gallery, '/') != strlen ($gallery) - 1) {
				$gallery = $gallery . '/';
			}
			
			$pic_info = pathinfo ($gallery);
			
			if (array_key_exists ("extension", $pic_info)) {
				$gallery = $pic_info["dirname"] . '/'; 
				$params['image'] = $pic_info["basename"];
			}
	
			$params['gallery'] =  $gallery;
		}
		
		return $params[$param];
	}
		
		
	function get_photo_uri () {
		return SITE_URL . GALLERY_ROOT;
	}
	
	
	// returns a photo uri
	function create_photo_uri ($photo, $page = '') {
		global $wp_rewrite;
	
		$do_rewrite = false;
		
		if (isset ($wp_rewrite) && $wp_rewrite->using_permalinks ()) {
			$do_rewrite = true;
		}
		
		$uri_photo =  ($do_rewrite) ? "${photo}" : "?" . GALLERY_PARAM . "=${photo}";
		
		$uri_offset = '';
		$uri_page = '';
		
		if ('' != $page) {
			$uri_page = ($do_rewrite) ? "/page/${page}" : "&amp;page=${page}";
		}
	
		
		return str_replace ('http:/' , 'http://', preg_replace ('/\/+/', '/', Currator::get_photo_uri () . "${uri_photo}${uri_page}"));
	}
	
	
	function photo_uri_to_image_uri ($location) {
		return str_replace (GALLERY_ROOT, '/' . GALLERY_FOLDER , $location);
	}
	
	
	function image_uri_to_photo_uri ($location) {
		return str_replace ('/' . GALLERY_FOLDER, GALLERY_ROOT, $location);
	}
}

?>
